//<c>   Copyright 1997-1999 by Gerry J. Danen; all rights reserved.

//<t>   NodeList Summary

#include"gd_tools.h"
#include"gd_ansi.h"


#define pgVERS_ "V2.00"
#define pgTITL_ "FTN-Compliant NodeList Summary"
#define pgCOPR_ "1997"
#define pgDATE_ __DATE__


#define BUFSIZE 10000
UCHAR   iPath[FS_LEN]="", iFile[FS_LEN]="", oFile[FS_LEN]="", iniFile[FS_LEN]="",
        work[BUFSIZE+2], *w, word[81], sZone[81]="", sExt[MAX_EXT]="SUM",
        fileList[3001], sMethod='A' ;
STRING  ans_lcyan = "[1;36m", ans_cyan = "[0;36m", ans_lwhite = "[1;37m",
        ans_white = "[0;37m", ans_lred = "[1;31m", ans_red = "[0;31m",
        ans_yellow = "[1;33m", ans_reset = "[0m", ans_cls = "[2J" ;
FILE    *iFh, *oFh, *ini ;
BOOL    ynANSI = FALSE, ynColours = FALSE ;
long    lDown=0, lHold=0, lHost=0, lHub=0, lNode=0, lPvt=0, lRegion=0, lZone=0,
        ltDown=0, ltHold=0, ltHost=0, ltHub=0, ltNode=0, ltPvt=0, ltRegion=0,
        lRecs=0 ;


void    no_ansi( void )
{
    *ans_lcyan = *ans_cyan = *ans_lwhite = *ans_white = *ans_lred = *ans_red =
    *ans_yellow = *ans_reset = *ans_cls = EOS ;
    ynANSI = ynColours = FALSE ;
}


void    reset_colours( void )
{
    fprintf( stderr, "%s", ans_reset );
}


void    cls( void )
{
    if ( ! ynANSI )
    {
        int x ;
        LOOP( x, 1, 20, 1 )                     // 20 blank lines
            fprintf( stderr, "\n" );
        return ;
    }

    fprintf( stderr, "%s%s", ans_white, ans_cls );
}


void    program_title( void )
{
    static BOOL already_done = FALSE ;

    if ( already_done )
        return ;

    fprintf( stderr, "%s%s %s %s %s  %s\n%s%s\n%s\n%s\n",
                     ans_lcyan, get_global_program_name(), pgVERS_,
                     ans_cyan, pgTITL_, pgDATE_,
                     ans_white, "Copyright (c) 1997 Stronghold Enterprises; all rights reserved.",
                                "Copyright (c) 1997-1998 Danen Information Services; all rights reserved.",
                                "" );

    already_done = TRUE ;
}


void    help( void )
{
    program_title();
    fprintf( stderr, "%s\nUsage:\t%s\n\n"
                     "%s%s makes use of %s.INI, which *must* be\n"
                     "in the same directory as %s.EXE.\n\n"
                     "The .INI file contains all processing parameters.\n\n",
                     ans_yellow,
                     get_global_program_name(),
                     ans_lwhite,
                     get_global_program_name(), get_global_program_name(),
                     get_global_program_name() );
    reset_colours();
    exit( GD_ERROR_HELP );
}


void    of_open( void )
{
    static BOOL ynFirst = TRUE ;

    if ( sMethod == 'A' )
    {
        fl_datafilename( oFile, iFile, sExt );
        ynFirst = TRUE ;
    }
    else
    {
        fl_datafilename( oFile, "nodesum.exe", sExt );
    }

    if ( ynFirst )
        oFh = fopen( oFile, "w" );              // overwrite if exists
    else
        oFh = fopen( oFile, "a" );              // append
    if ( oFh == NULL )
    {
        fprintf( stderr, "%s\nCannot create output file %s\a\n", ans_lred, oFile );
        exit( GD_ERROR_CANNOT_OPEN_FOR_WRITE );
    }

    if ( ynFirst )
    {
        fprintf( oFh, "Nodelist Summary created by %s %s on %s %s %s\n",
                      get_global_program_name(), pgVERS_,
                      TodaysDay(), TodaysCDate(), TodaysTime() );
    }

    ynFirst = FALSE ;
}


void    of_close( void )
{
    fclose( oFh );
}


void    find_input_filename( void )
{
    struct _find_t nl ;
    unsigned    done, attrib = REGULAR_FILES ;  // all except directories, and volid
    char        sToFind[FS_LEN] ;               // file spec to search for
    char        fSpec[FS_LEN] ;                 // file spec to keep
    char        fn[FS_LEN] ;                    // temp storage
    UCHAR       work1[1001], work2[1001] ;
    int         x, day, month, year, hour, minute, secs ;
    INT32       ymdC=-1, ymdP=-1, hmsC=-1, hmsP=-1 ;

    ST_CPY( fn, iFile );

    if ( ST_EMPTY(iPath) )
        sprintf( sToFind, "%s.*", iFile );
    else
        sprintf( sToFind, "%s\\%s.*", iPath, iFile );

    done = _dos_findfirst( sToFind, attrib, &nl );  // phase 1 - see what we have

    if ( done )                                 // no files
    {
        ST_CLR( iFile );
        return ;
    }

    while ( ! done )
    {
        _strlwr( nl.name );
        strcpy( work, nl.name );

        x = strlen(fn) + 1 ;
        if ( isdigit(work[x])   &&
             isdigit(work[x+1]) &&
             isdigit(work[x+2]) )
        {
            Fstamp2date( nl.wr_date, &year, &month, &day );
            Fstamp2time( nl.wr_time, &hour, &minute, &secs );

            ymdC = dt_ymd( day, month, year );
            hmsC = hour*10000L + minute*100L + secs ;

            if ( (ymdC > ymdP) ||
                (ymdC == ymdP && hmsC > hmsP) )
            {
                ymdP = ymdC ;
                hmsP = hmsC ;
                strcpy( fSpec, nl.name );
            }
        }
        done = _dos_findnext( &nl );           // find next file
    }

    done = _dos_findfirst( sToFind, attrib, &nl );  // phase 2 - do the actual work
    while ( ! done )
    {
        _strlwr( nl.name );
        strcpy( work, nl.name );

        x = strlen(fn) + 1 ;
        if ( isdigit(work[x])   &&
             isdigit(work[x+1]) &&
             isdigit(work[x+2]) )
        {
            Fstamp2date( nl.wr_date, &year, &month, &day );
            Fstamp2time( nl.wr_time, &hour, &minute, &secs );
            ymdC = dt_ymd( day, month, year );
            hmsC = hour*10000L + minute*100L + secs ;
            FormatDate( ymdC, work1, 9 );
            FormatTime( hmsC, work2, 1, 2 );

            if ( st_eq(work, fSpec) )
            {
                strcpy( iFile, fSpec );
                return ;
            }
        }
        done = _dos_findnext( &nl );           // find next file
    }
}


void    process_unknown( void )
{
    strupr( word );
    work[38] = EOS ;
    fprintf( stderr, "\rUnknown entry \"%s\" at line %-6ld-> %s\n", word, lRecs, work );
}


void    process_zone( void )
{
    if ( ST_EMPTY(sZone) )                      // first time, just
        goto done ;                             //  some init stuff to do

    fprintf( oFh, "\nZone %s contains:\t%ld region%s; %ld net%s; %ld hub%s\n",
                  sZone,
                  lRegion, ONE_OR_MORE(lRegion ),
                  lHost  , ONE_OR_MORE(lHost   ),
                  lHub   , ONE_OR_MORE(lHub    ) );
    fprintf( oFh, "\t\t\t%ld node%s: %ld private, %ld down, %ld on hold\n",
                  lNode,   ONE_OR_MORE(lNode   ),
                  lPvt,
                  lDown,
                  lHold );

    lZone    += 1 ;
    ltRegion += lRegion ;
    ltHost   += lHost   ;
    ltHub    += lHub    ;
    ltNode   += lNode   ;
    ltPvt    += lPvt    ;
    ltDown   += lDown   ;
    ltHold   += lHold   ;

done:
    lRegion = lHost = lHub = lNode = lPvt = lDown = lHold = 0 ;

    st_get_word( sZone, work );                 // extract zone for next one
}


void    process_totals( void )
{
    process_zone();                             // for the last one

    if ( ST_EMPTY(sZone) )                      // no data
        return ;

    fprintf( stderr, "\r%39s\n%s%10ld data record%s processed:\n"
                     "\t\t%7ld node%s in total,\n"
                     "\t\t%7ld node%s down,\n"
                     "\t\t%7ld node%s on hold,\n"
                     "\t\t%7ld host (net) node%s,\n"
                     "\t\t%7ld hub node%s,\n"
                     "\t\t%7ld private node%s,\n"
                     "\t\t%7ld region%s,\n"
                     "\t\t%7ld zone%s.\n\n"
                     "%sOutput file is %s\n",
             "", ans_lred,
             lRecs,    ONE_OR_MORE(lRecs    ),
             ltNode,   ONE_OR_MORE(ltNode   ),
             ltDown,   ONE_OR_MORE(ltDown   ),
             ltHold,   ONE_OR_MORE(ltHold   ),
             ltHost,   ONE_OR_MORE(ltHost   ),
             ltHub,    ONE_OR_MORE(ltHub    ),
             ltPvt,    ONE_OR_MORE(ltPvt    ),
             ltRegion, ONE_OR_MORE(ltRegion ),
             lZone,    ONE_OR_MORE(lZone    ),
             ans_yellow, oFile );

    if ( lZone < 2 )                            // only a single zone
        return ;                                // no need for totals in report

    fprintf( oFh, "\nNodelist contains:\t%ld zone%s; %ld region%s; %ld net%s; %ld hub%s\n",
                  lZone   , ONE_OR_MORE(lZone    ),
                  ltRegion, ONE_OR_MORE(ltRegion ),
                  ltHost  , ONE_OR_MORE(ltHost   ),
                  ltHub   , ONE_OR_MORE(ltHub    ) );
    fprintf( oFh, "\t\t\t%ld node%s: %ld private, %ld down, %ld on hold\n",
                  ltNode,   ONE_OR_MORE(ltNode   ),
                  ltPvt,
                  ltDown,
                  ltHold );
}


void    do_parm( STRING par )
{
    _strupr( par );
    if ( *par == '?' || *par == 'H' )
        help();
    if ( st_eq(par, "noansi") )
    {
        no_ansi();
        return ;
    }
    program_title();
    fprintf( stderr, "%s\n/%s is an invalid switch\a\n", ans_lred, par );
    help();
}


void    process_nodelist( void )
{
    int         x ;
    UCHAR       myFile[FS_LEN] ;

    find_input_filename();
    if ( ST_EMPTY(iFile) )
        return ;

    lDown = lHold = lHost = lHub = lNode = lPvt = lRegion = lZone = ltDown =
    ltHold = ltHost = ltHub = ltNode = ltPvt = ltRegion = lRecs = 0 ;
    sZone[0] = EOS ;

    of_open();

    if ( ST_EMPTY(iPath) )
        sprintf( myFile, "%s", iFile );
    else
        sprintf( myFile, "%s\\%s", iPath, iFile );

    if ( ( iFh = fopen( myFile, "r" ) ) == NULL )
    {
        fprintf( stderr, "%s\nNodelist file %s not found\a\n", ans_lred, myFile );
        fprintf( oFh, "Nodelist file %s not found\n", myFile );
        help();
    }

    fprintf( stderr, "%s\nProcessing nodelist file %s\n", ans_lwhite, myFile );
    fprintf( oFh, "\n\n>> Nodelist %s <<\n", myFile );

    while ( (w = fgets( work, BUFSIZE, iFh )) )
    {
        st_trim( work );                        // remove leading/trailing spaces
        if ( work[0] != ';' )                   // ignore comments
        {
            st_remove_spaces( work );           // remove embedded spaces
            lRecs ++ ;                          // count data records
            if ( ! (lRecs % 100L) )
                fprintf( stderr, "\r%ld", lRecs ); // show progress
            LOOP(x, 0, ((int)strlen(work)), 1)  // change all commas to spaces
            {
                if ( work[x] == ',' )
                    work[x] = ' ' ;
            }
            if ( work[0] == ' ' )               // first char _was_ a ","
            {
                lNode ++ ;
            }
            else                                // we might have a special entry
            {                                   //  .. Down, Hold, Host, Hub, Pvt, Region, Zone
                st_get_word( word, work );      // get first word in string
                st_remove_word( work );         // remove first word in string
                if ( st_eq(word, "down") )
                {
                    lDown ++ ;
                }
                else
                if ( st_eq(word, "hold") )
                {
                    lHold ++ ;
                }
                else
                if ( st_eq(word, "host") )
                {
                    lHost ++ ;
                }
                else
                if ( st_eq(word, "hub") )
                {
                    lHub ++ ;
                }
                else
                if ( st_eq(word, "pvt") )
                {
                    lPvt ++ ;
                }
                else
                if ( st_eq(word, "region") )
                {
                    lRegion ++ ;
                }
                else
                if ( st_eq(word, "zone") )
                {
                    process_zone();
                }
                else
                    process_unknown();
            }
        }
    }

    process_totals();                           // grand totals
    of_close();
}


void    create_filelist( void )
{
    FILE *f ;
    BOOL inNODELISTS = FALSE ;

    ST_CLR( fileList );
    if ( ( f = fopen( iniFile, "r" ) ) == NULL )
    {
        fprintf( stderr, "%s\nCan't open %s to get nodelist names\a\n", ans_lred, iniFile );
        help();
    }
    while ( (w = fgets( work, BUFSIZE, f )) )
    {
        strupr( work );
        st_trim( work );
        if ( strlen(work) && work[0] != ';' )
        {
            if ( *work == '[' )
            {
                *work = SPACE ;
                ST_CLR_LASTCHAR(work);
                st_trim( work );
                if ( st_eq(work, "nodelists") )
                    inNODELISTS = TRUE ;
                else
                    inNODELISTS = FALSE ;
                ST_CLR(work);
            }
            if ( inNODELISTS )
            {
                ST_CAT( fileList, " "  );
                ST_CAT( fileList, work );
            }
        }
    }
    fclose( f );
    st_trim( fileList );
}


void    main( int argc, char *argv[] )
{
    int         xcnt = 0 ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );

    if ( _isatty( _fileno(stdout) ) )
    {
        if ( ISLOADED_ANSI() )
            ynANSI = ynColours = TRUE ;
        if ( ! ynColours )
            no_ansi();
    }

    if ( argc > 1 )                             // no arguments needed
        help();

    if ( fl_datafilename( iniFile, argv[0], "ini" ) == ERROR )
    {
        fprintf( stderr, "%s\nCan't find %s...\a\n", ans_lred, iniFile );
        help();
    }

    fl_parse_ini( iniFile, "nodesum", "ansi", word, &xcnt ); // get ansi mode
    strupr( word );
    if ( word[0]=='N' || word[0]=='0' )         // user doesn't want ansi
        no_ansi();

    if ( _isatty( _fileno(stdout) ) )
        cls();

    fl_parse_ini( iniFile, "nodesum", "nodelists", word, &xcnt ); // get path
    if ( ! ST_EMPTY(word) )
        ST_CPY( iPath, word );

    program_title();

    fl_parse_ini( iniFile, "output", "ext", word, &xcnt ); // get output extension
    if ( ! ST_EMPTY(word) )
        ST_CPY( sExt, word );

    fl_parse_ini( iniFile, "output", "method", word, &xcnt ); // get output method
    strupr( word );
    if ( word[0] == 'B' )
        sMethod = 'B' ;

    create_filelist();
    printf( "Nodelists to process: [%s%s%s]\n", ans_yellow, fileList, ans_white );

    while ( strlen(fileList) )
    {
        st_get_word( iFile, fileList );         // get file name from list
        st_remove_word( fileList );             // remove from list
        process_nodelist();
    }

    _fcloseall();

    fprintf( stderr, "\n%s%s is \"Y2K\"-compliant, even though your operating system may not be.\n"
                     "File dates are outside of the control of this program and depend on your\n"
                     "O/S being \"Y2K\"-compliant.\n\n",
                     ans_lcyan, get_global_program_name() );

    reset_colours();
    exit( GD_ERROR_NONE );
}
